'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

/*
 * 类型不一样就停止比较,直接使用新数据
 * 基本数据类型直接比较
 * 只在同层节点做对比
 * */
var keyList = Object.keys;
var hasProp = Object.prototype.hasOwnProperty;
var isArray = function (arg) {
    return Array.isArray(arg);
};
var diffArrToPath = function (to, from, res, keyPrev) {
    if ( res === void 0 ) res = {};
    if ( keyPrev === void 0 ) keyPrev = '';

    var len = to.length;
    var loop = function ( i ) {
        var toItem = to[i];
        var fromItem = from[i];
        var targetKey = keyPrev + "[" + i + "]";
        if (toItem === fromItem) {
            return;
        }
        else if (typeof toItem !== typeof fromItem) {
            res[targetKey] = toItem;
        }
        else {
            if (typeof toItem !== 'object') {
                res[targetKey] = toItem;
            }
            else {
                var arrTo = isArray(toItem);
                var arrFrom = isArray(fromItem);
                if (arrTo !== arrFrom) {
                    res[targetKey] = toItem;
                }
                else if (arrTo && arrFrom) {
                    if (toItem.length < fromItem.length) {
                        res[targetKey] = toItem;
                    }
                    else {
                        // 数组
                        diffArrToPath(toItem, fromItem, res, ("" + targetKey));
                    }
                }
                else {
                    if (!toItem || !fromItem || keyList(toItem).length < keyList(fromItem).length) {
                        res[targetKey] = toItem;
                    }
                    else {
                        // 对象
                        var shouldDiffObject = true;
                        Object.keys(fromItem).some(function (key) {
                            if (typeof toItem[key] === 'undefined') {
                                shouldDiffObject = false;
                                return true;
                            }
                        });
                        if (shouldDiffObject) {
                            diffObjToPath(toItem, fromItem, res, (targetKey + "."));
                        }
                        else {
                            res[targetKey] = toItem;
                        }
                    }
                }
            }
        }
    };

    for (var i = 0; i < len; i++) loop( i );
    return res;
};
var diffObjToPath = function (to, from, res, keyPrev) {
    if ( res === void 0 ) res = {};
    if ( keyPrev === void 0 ) keyPrev = '';

    if (to == null) {
        res[keyPrev] = null;
        return res;
    }
    if (from == null) {
        res[keyPrev] = to;
        return res;
    }
    var keys = keyList(to);
    var len = keys.length;
    var loop = function ( i ) {
        var key = keys[i];
        var toItem = to[key];
        var fromItem = from[key];
        var targetKey = "" + keyPrev + key;
        if (toItem === fromItem) {
            return;
        }
        else if (!hasProp.call(from, key)) {
            res[targetKey] = toItem;
        }
        else if (typeof toItem !== typeof fromItem) {
            res[targetKey] = toItem;
        }
        else {
            if (typeof toItem !== 'object') {
                res[targetKey] = toItem;
            }
            else {
                var arrTo = isArray(toItem);
                var arrFrom = isArray(fromItem);
                if (arrTo !== arrFrom) {
                    res[targetKey] = toItem;
                }
                else if (arrTo && arrFrom) {
                    if (toItem.length < fromItem.length) {
                        res[targetKey] = toItem;
                    }
                    else {
                        // 数组
                        diffArrToPath(toItem, fromItem, res, ("" + targetKey));
                    }
                }
                else {
                    // null
                    if (!toItem || !fromItem) {
                        res[targetKey] = toItem;
                    }
                    else {
                        // 对象
                        var shouldDiffObject = true;
                        Object.keys(fromItem).some(function (key) {
                            if (typeof toItem[key] === 'undefined') {
                                shouldDiffObject = false;
                                return true;
                            }
                        });
                        if (shouldDiffObject) {
                            diffObjToPath(toItem, fromItem, res, (targetKey + "."));
                        }
                        else {
                            res[targetKey] = toItem;
                        }
                    }
                }
            }
        }
    };

    for (var i = 0; i < len; i++) loop( i );
    return res;
};
var diff = function (newData, oldData, keyPrev) {
    if ( keyPrev === void 0 ) keyPrev = '';

    var target = {};
    diffObjToPath(newData, oldData, target, keyPrev);
    return target;
};

exports.diff = diff;
//# sourceMappingURL=index.js.map
